// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: inventory.proto
// </auto-generated>
#pragma warning disable 0414, 1591
#region Designer generated code

using grpc = global::Grpc.Core;

namespace Item {
  public static partial class ItemService
  {
    static readonly string __ServiceName = "item.ItemService";

    static void __Helper_SerializeMessage(global::Google.Protobuf.IMessage message, grpc::SerializationContext context)
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (message is global::Google.Protobuf.IBufferMessage)
      {
        context.SetPayloadLength(message.CalculateSize());
        global::Google.Protobuf.MessageExtensions.WriteTo(message, context.GetBufferWriter());
        context.Complete();
        return;
      }
      #endif
      context.Complete(global::Google.Protobuf.MessageExtensions.ToByteArray(message));
    }

    static class __Helper_MessageCache<T>
    {
      public static readonly bool IsBufferMessage = global::System.Reflection.IntrospectionExtensions.GetTypeInfo(typeof(global::Google.Protobuf.IBufferMessage)).IsAssignableFrom(typeof(T));
    }

    static T __Helper_DeserializeMessage<T>(grpc::DeserializationContext context, global::Google.Protobuf.MessageParser<T> parser) where T : global::Google.Protobuf.IMessage<T>
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (__Helper_MessageCache<T>.IsBufferMessage)
      {
        return parser.ParseFrom(context.PayloadAsReadOnlySequence());
      }
      #endif
      return parser.ParseFrom(context.PayloadAsNewBuffer());
    }

    static readonly grpc::Marshaller<global::Item.ItemType> __Marshaller_item_ItemType = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Item.ItemType.Parser));
    static readonly grpc::Marshaller<global::Common.ItemId> __Marshaller_common_ItemId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.ItemId.Parser));
    static readonly grpc::Marshaller<global::Item.Item> __Marshaller_item_Item = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Item.Item.Parser));
    static readonly grpc::Marshaller<global::Item.AddItemToInventoryCall> __Marshaller_item_AddItemToInventoryCall = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Item.AddItemToInventoryCall.Parser));
    static readonly grpc::Marshaller<global::Common.ResponseStatus> __Marshaller_common_ResponseStatus = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.ResponseStatus.Parser));
    static readonly grpc::Marshaller<global::Common.UserId> __Marshaller_common_UserId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.UserId.Parser));
    static readonly grpc::Marshaller<global::Item.Inventory> __Marshaller_item_Inventory = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Item.Inventory.Parser));
    static readonly grpc::Marshaller<global::Item.Page> __Marshaller_item_Page = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Item.Page.Parser));
    static readonly grpc::Marshaller<global::Item.ItemDefList> __Marshaller_item_ItemDefList = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Item.ItemDefList.Parser));

    static readonly grpc::Method<global::Item.ItemType, global::Common.ItemId> __Method_CreateItemByType = new grpc::Method<global::Item.ItemType, global::Common.ItemId>(
        grpc::MethodType.Unary,
        __ServiceName,
        "CreateItemByType",
        __Marshaller_item_ItemType,
        __Marshaller_common_ItemId);

    static readonly grpc::Method<global::Item.Item, global::Common.ItemId> __Method_AddItem = new grpc::Method<global::Item.Item, global::Common.ItemId>(
        grpc::MethodType.Unary,
        __ServiceName,
        "AddItem",
        __Marshaller_item_Item,
        __Marshaller_common_ItemId);

    static readonly grpc::Method<global::Item.AddItemToInventoryCall, global::Common.ResponseStatus> __Method_AddItemToInventory = new grpc::Method<global::Item.AddItemToInventoryCall, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "AddItemToInventory",
        __Marshaller_item_AddItemToInventoryCall,
        __Marshaller_common_ResponseStatus);

    static readonly grpc::Method<global::Common.ItemId, global::Item.Item> __Method_GetItem = new grpc::Method<global::Common.ItemId, global::Item.Item>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetItem",
        __Marshaller_common_ItemId,
        __Marshaller_item_Item);

    static readonly grpc::Method<global::Common.UserId, global::Item.Inventory> __Method_GetInventory = new grpc::Method<global::Common.UserId, global::Item.Inventory>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetInventory",
        __Marshaller_common_UserId,
        __Marshaller_item_Inventory);

    static readonly grpc::Method<global::Item.Item, global::Common.ResponseStatus> __Method_UpdateItem = new grpc::Method<global::Item.Item, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "UpdateItem",
        __Marshaller_item_Item,
        __Marshaller_common_ResponseStatus);

    static readonly grpc::Method<global::Common.ItemId, global::Common.ResponseStatus> __Method_DeleteItem = new grpc::Method<global::Common.ItemId, global::Common.ResponseStatus>(
        grpc::MethodType.Unary,
        __ServiceName,
        "DeleteItem",
        __Marshaller_common_ItemId,
        __Marshaller_common_ResponseStatus);

    static readonly grpc::Method<global::Item.Page, global::Item.ItemDefList> __Method_GetItemDefinitions = new grpc::Method<global::Item.Page, global::Item.ItemDefList>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetItemDefinitions",
        __Marshaller_item_Page,
        __Marshaller_item_ItemDefList);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Item.InventoryReflection.Descriptor.Services[0]; }
    }

    /// <summary>Base class for server-side implementations of ItemService</summary>
    [grpc::BindServiceMethod(typeof(ItemService), "BindService")]
    public abstract partial class ItemServiceBase
    {
      public virtual global::System.Threading.Tasks.Task<global::Common.ItemId> CreateItemByType(global::Item.ItemType request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ItemId> AddItem(global::Item.Item request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> AddItemToInventory(global::Item.AddItemToInventoryCall request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Item.Item> GetItem(global::Common.ItemId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Item.Inventory> GetInventory(global::Common.UserId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> UpdateItem(global::Item.Item request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Common.ResponseStatus> DeleteItem(global::Common.ItemId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Item.ItemDefList> GetItemDefinitions(global::Item.Page request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for ItemService</summary>
    public partial class ItemServiceClient : grpc::ClientBase<ItemServiceClient>
    {
      /// <summary>Creates a new client for ItemService</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public ItemServiceClient(grpc::ChannelBase channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for ItemService that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public ItemServiceClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected ItemServiceClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected ItemServiceClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      public virtual global::Common.ItemId CreateItemByType(global::Item.ItemType request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return CreateItemByType(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ItemId CreateItemByType(global::Item.ItemType request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_CreateItemByType, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ItemId> CreateItemByTypeAsync(global::Item.ItemType request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return CreateItemByTypeAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ItemId> CreateItemByTypeAsync(global::Item.ItemType request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_CreateItemByType, null, options, request);
      }
      public virtual global::Common.ItemId AddItem(global::Item.Item request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddItem(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ItemId AddItem(global::Item.Item request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_AddItem, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ItemId> AddItemAsync(global::Item.Item request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddItemAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ItemId> AddItemAsync(global::Item.Item request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_AddItem, null, options, request);
      }
      public virtual global::Common.ResponseStatus AddItemToInventory(global::Item.AddItemToInventoryCall request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddItemToInventory(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus AddItemToInventory(global::Item.AddItemToInventoryCall request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_AddItemToInventory, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> AddItemToInventoryAsync(global::Item.AddItemToInventoryCall request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return AddItemToInventoryAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> AddItemToInventoryAsync(global::Item.AddItemToInventoryCall request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_AddItemToInventory, null, options, request);
      }
      public virtual global::Item.Item GetItem(global::Common.ItemId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItem(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Item.Item GetItem(global::Common.ItemId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetItem, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Item.Item> GetItemAsync(global::Common.ItemId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItemAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Item.Item> GetItemAsync(global::Common.ItemId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetItem, null, options, request);
      }
      public virtual global::Item.Inventory GetInventory(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetInventory(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Item.Inventory GetInventory(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetInventory, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Item.Inventory> GetInventoryAsync(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetInventoryAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Item.Inventory> GetInventoryAsync(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetInventory, null, options, request);
      }
      public virtual global::Common.ResponseStatus UpdateItem(global::Item.Item request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return UpdateItem(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus UpdateItem(global::Item.Item request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_UpdateItem, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> UpdateItemAsync(global::Item.Item request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return UpdateItemAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> UpdateItemAsync(global::Item.Item request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_UpdateItem, null, options, request);
      }
      public virtual global::Common.ResponseStatus DeleteItem(global::Common.ItemId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return DeleteItem(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Common.ResponseStatus DeleteItem(global::Common.ItemId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_DeleteItem, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> DeleteItemAsync(global::Common.ItemId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return DeleteItemAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Common.ResponseStatus> DeleteItemAsync(global::Common.ItemId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_DeleteItem, null, options, request);
      }
      public virtual global::Item.ItemDefList GetItemDefinitions(global::Item.Page request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItemDefinitions(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Item.ItemDefList GetItemDefinitions(global::Item.Page request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetItemDefinitions, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Item.ItemDefList> GetItemDefinitionsAsync(global::Item.Page request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetItemDefinitionsAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Item.ItemDefList> GetItemDefinitionsAsync(global::Item.Page request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetItemDefinitions, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override ItemServiceClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new ItemServiceClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(ItemServiceBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_CreateItemByType, serviceImpl.CreateItemByType)
          .AddMethod(__Method_AddItem, serviceImpl.AddItem)
          .AddMethod(__Method_AddItemToInventory, serviceImpl.AddItemToInventory)
          .AddMethod(__Method_GetItem, serviceImpl.GetItem)
          .AddMethod(__Method_GetInventory, serviceImpl.GetInventory)
          .AddMethod(__Method_UpdateItem, serviceImpl.UpdateItem)
          .AddMethod(__Method_DeleteItem, serviceImpl.DeleteItem)
          .AddMethod(__Method_GetItemDefinitions, serviceImpl.GetItemDefinitions).Build();
    }

    /// <summary>Register service method with a service binder with or without implementation. Useful when customizing the  service binding logic.
    /// Note: this method is part of an experimental API that can change or be removed without any prior notice.</summary>
    /// <param name="serviceBinder">Service methods will be bound by calling <c>AddMethod</c> on this object.</param>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static void BindService(grpc::ServiceBinderBase serviceBinder, ItemServiceBase serviceImpl)
    {
      serviceBinder.AddMethod(__Method_CreateItemByType, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Item.ItemType, global::Common.ItemId>(serviceImpl.CreateItemByType));
      serviceBinder.AddMethod(__Method_AddItem, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Item.Item, global::Common.ItemId>(serviceImpl.AddItem));
      serviceBinder.AddMethod(__Method_AddItemToInventory, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Item.AddItemToInventoryCall, global::Common.ResponseStatus>(serviceImpl.AddItemToInventory));
      serviceBinder.AddMethod(__Method_GetItem, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.ItemId, global::Item.Item>(serviceImpl.GetItem));
      serviceBinder.AddMethod(__Method_GetInventory, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.UserId, global::Item.Inventory>(serviceImpl.GetInventory));
      serviceBinder.AddMethod(__Method_UpdateItem, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Item.Item, global::Common.ResponseStatus>(serviceImpl.UpdateItem));
      serviceBinder.AddMethod(__Method_DeleteItem, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.ItemId, global::Common.ResponseStatus>(serviceImpl.DeleteItem));
      serviceBinder.AddMethod(__Method_GetItemDefinitions, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Item.Page, global::Item.ItemDefList>(serviceImpl.GetItemDefinitions));
    }

  }
}
#endregion
